﻿/*
Esta clase se encargara de crear una nueva lista, tomando de la libreria un boton
modelo y duplicandolo, dando la opcion de poder pasarle un numero de columnas o si
los botones tendras la funcion presionado.
*/
class Lista extends MovieClip {
	// Primero definimos las variables que usaremos dentro de la clase
	var datos:Array;
	//array que contendra los datos de los botones, como nombre, accion, etc
	var linkage:String;
	//el nombre del linkeage que tendra el boton en la libreria
	var columnas:Number;
	//cantidad de columnas en la que se mostraran los botones
	var sep:Number;
	//separacion en pixeles entre los botones
	var press:Boolean;
	//variable booleana que define si los botones tienen estado presionado o no
	/*
	funcion constructora de la clase, en este caso no tiene nada
	*/
	public function Lista() {
	}
	/*
	METODOS:
	la funcion "crear" crea, como su nombre lo dice, el listado de botones.
	pasamos los parametros necesarios, explicados arriba
	*/
	public function crear(p_datos:Array, p_linkage:String, p_columnas:Number, p_sep:Number, p_press:Boolean) {
		this._visible = true;
		// hacemos visible la lista
		// variable para acomodar el boton en X e Y segun el numero de columnas
		var x:Number = 0;
		var y:Number = 0;
		// asignamos los parametros a las variables de la clase
		this.datos = p_datos;
		this.linkage = p_linkage;
		this.sep = p_sep;
		this.columnas = p_columnas;
		this.press = p_press;
		// bucle for que genera la lista de botones duplicandolos
		for (var i:Number = 0; i<datos.length; i++) {
			var item:MovieClip = this.attachMovie(linkage, "item"+i, i);
			//genera una variable item donde guardamos la referencia al nuevo boton
			//lo posicionamos en X e Y
			item._x = (item._width+sep)*x;
			item._y = (item._height+sep)*y;
			item._press = press;
			//asiganmos el valor pasado como press al metodo press de la clase Boton
			item._pos = i;
			//guardamos la posicion del boton para acciones futuras
			var ruta:Object = this;
			// asignamos a la variable "ruta" la referencia de la clase para usarla dentro de otros metodos y no perder su referencia
			//le asignamos una accion al metodo click creado en la clase Boton (o sea lo que va a hacer el boton)
			item.click = function() {
				trace(ruta.datos[this._pos].dato);
			};
			item.label_txt.text = datos[i].label;
			// ponemos el texto del boton en el campo de texto dinamico que el mismo tiene
			x++;
			//aumentamos el valor de "x" para generar columnas
			// si "x" es igual a columnas vuelve a 0 y aumenta "y" para bajar a la siguiente fila
			if (x == columnas) {
				x = 0;
				y++;
			}
		}
	}
}
//fin de clase Lista
